import React, {useState }  from 'react';
import logo from './logo.svg';
import './App.css';
import {Provider, connect}   from 'react-redux';
import {actionSearch } from './actions';
import store from './reducers'
//import { CounterView, Counter, ConnectedBIGTABLO, ConnectedCounter, ConnectedBigButton } from './components'
import {Router, Route, Link, Switch, Redirect} from 'react-router-dom';
import createHistory from "history/createBrowserHistory";

import {actionCategories, actionLogin} from './actions'


const history = createHistory()

const Post = ({post}) =>
<div>
    <h2>{post.title}</h2>
    <p>{post.text}</p>
</div>

const PostFeed = ({posts=[]}) =>
<div>
    {posts && posts.map(p => <Post post={p}/>)}
</div>

const CPostFeed = connect(s => ({posts:s.promise.posts && 
                                       s.promise.posts.payload && 
                                       s.promise.posts.payload.getPosts}))(PostFeed)

const PageMain = () =>
<>
    <CPostFeed />
</>

const LoginForm = ({onLogin}) => {
    const [login, setLogin] = useState("")
    const [password, setPassword] = useState("")
    return (
            <div>
                <input type='text' value={login} onChange={e => setLogin(e.target.value)} />
                <input type='password' value={password} onChange={e => setPassword(e.target.value)} />
                <button onClick={() => onLogin(login, password)}>Login</button>
            </div>
        )
}
const CLoginForm = connect(null, {onLogin: actionLogin})(LoginForm)


store.dispatch(actionCategories())

const CategoryMenuItem = ({category:{_id, name}={_id: 'NOID', name: "NO CATEGORY"}}) =>
<li>
    <a href={`/category/${_id}`}>{name}</a>
</li>

const CategoryMenu = ({categories=
[
      { "_id": "5dc45acf5df9d670df48cc48", "name": "TV's" },
      { "_id": "5dc49f4d5df9d670df48cc64", "name": "Airconditions" },
      { "_id": "5dc458985df9d670df48cc47", "name": "Smartphones" },
    ]
}) =>
<aside>
    <ul>
        {categories && 
            categories.map(category => <CategoryMenuItem category={category}/>)}
    </ul>
</aside>

const CCategoryMenu = connect(state => ({categories: state.promise.categories && 
                                                     state.promise.categories.payload && 
                                                     state.promise.categories.payload.CategoryFind}))(CategoryMenu)

export default () => {
    return (
        <Provider store={store}>
            <CategoryMenu />
            <CCategoryMenu />
        { /* <CLoginForm />
            <Router history={history}>
                <Route path="/" component={PageMain} />
            </Router> */ }
        </Provider>
    )
}
